# Class TEmbeddedChromium

Description
Hierarchy
Fields
Methods
Properties

## Unit

uCEFBrowserWindow

## Declaration

`type TEmbeddedChromium = class(TChromium)`

## Description

TEmbeddedChromium

1) TEmbeddedChromium keeps track of the browser while it is created. This allows for CloseBrowser to function, even if the Browser object is not yet known. Also calls to "LoadUrl" are cached until the browser object is created.

2) TEmbeddedChromium adds InternalEvents that can be hooked by the component that owns the TEmbeddedChromium. This means the default published events are available to the end user. Published events that should not be available are hidden via THiddenPropertyEditor * Hidden event properties must not be assigned by any end user code. *

## Hierarchy

- TObject
- TPersistent
- TComponent
- TChromiumCore
- TChromium
- TEmbeddedChromium

## Overview

### Methods

| `function GetHasBrowser: boolean; reintroduce;`
| `procedure doOnBeforeClose(const ABrowser: ICefBrowser); override;`
| `procedure doOnAfterCreated(const ABrowser: ICefBrowser); override;`
| `procedure doOnGotFocus(const Abrowser: ICefBrowser); override;`
| `function MustCreateFocusHandler: boolean; override;`
| `procedure DoCreated(Data: PtrInt);`
| `procedure DoOnClosed(Data: PtrInt);`
| `constructor Create(AOwner: TComponent); override;`
| `destructor Destroy; override;`
| `function CreateBrowser(const aBrowserParent: TWinControl = nil; const aWindowName: ustring = ''; const aContext: ICefRequestContext = nil; const aExtraInfo: ICefDictionaryValue = nil): boolean; overload; override;`
| `function CreateBrowser(aParentHandle: TCefWindowHandle; aParentRect: TRect; const aWindowName: ustring = ''; const aContext: ICefRequestContext = nil; const aExtraInfo: ICefDictionaryValue = nil; aForceAsPopup : boolean = False): boolean; overload; override;`
| `function CreateBrowser(const aURL: ustring; const aBrowserViewComp: TCEFBrowserViewComponent; const aContext: ICefRequestContext = nil; const aExtraInfo: ICefDictionaryValue = nil): boolean; overload; override;`
| `procedure CloseBrowser(aForceClose: boolean); reintroduce;`
| `procedure LoadURL(const aURL: ustring; const aFrameName: ustring = ''); overload;`

### Properties

| `property HasBrowser: Boolean read GetHasBrowser;`
| `property IsClosing : Boolean read GetIsClosing;`
| `property InternalOnBrowserCreated : TNotifyEvent read FInternalOnBrowserCreated write FInternalOnBrowserCreated;`
| `property InternalOnBrowserClosed : TNotifyEvent read FInternalOnBrowserClosed write FInternalOnBrowserClosed;`
| `property InternalOnGotFocus : TOnGotFocus read FInternalOnGotFocus write FInternalOnGotFocus;`

## Description

### Methods

| `function GetHasBrowser: boolean; reintroduce;`
This item has no description.

| `procedure doOnBeforeClose(const ABrowser: ICefBrowser); override;`
This item has no description.

| `procedure doOnAfterCreated(const ABrowser: ICefBrowser); override;`
This item has no description.

| `procedure doOnGotFocus(const Abrowser: ICefBrowser); override;`
This item has no description.

| `function MustCreateFocusHandler: boolean; override;`
This item has no description.

| `procedure DoCreated(Data: PtrInt);`
This item has no description.

| `procedure DoOnClosed(Data: PtrInt);`
This item has no description.

| `constructor Create(AOwner: TComponent); override;`
This item has no description.

| `destructor Destroy; override;`
This item has no description.

| `function CreateBrowser(const aBrowserParent: TWinControl = nil; const aWindowName: ustring = ''; const aContext: ICefRequestContext = nil; const aExtraInfo: ICefDictionaryValue = nil): boolean; overload; override;`
This item has no description. Showing description inherited from TChromium.CreateBrowser. Used to create the browser after the global request context has been initialized. You need to set all properties and events before calling this function because it will only create the internal handlers needed for those events and the property values will be used in the browser initialization. The browser will be fully initialized when the TChromiumCore.OnAfterCreated event is triggered.

| `function CreateBrowser(aParentHandle: TCefWindowHandle; aParentRect: TRect; const aWindowName: ustring = ''; const aContext: ICefRequestContext = nil; const aExtraInfo: ICefDictionaryValue = nil; aForceAsPopup : boolean = False): boolean; overload; override;`
This item has no description. Showing description inherited from TChromiumCore.CreateBrowser. Used to create the browser after the global request context has been initialized. You need to set all properties and events before calling this function because it will only create the internal handlers needed for those events and the property values will be used in the browser initialization. The browser will be fully initialized when the TChromiumCore.OnAfterCreated event is triggered.

| `function CreateBrowser(const aURL: ustring; const aBrowserViewComp: TCEFBrowserViewComponent; const aContext: ICefRequestContext = nil; const aExtraInfo: ICefDictionaryValue = nil): boolean; overload; override;`
This item has no description. Showing description inherited from TChromiumCore.CreateBrowser. Used to create the browser after the global request context has been initialized. You need to set all properties and events before calling this function because it will only create the internal handlers needed for those events and the property values will be used in the browser initialization. The browser will be fully initialized when the TChromiumCore.OnAfterCreated event is triggered.

| `procedure CloseBrowser(aForceClose: boolean); reintroduce;`
CloseBrowser will work, even if the browser is still in creation, and Initialized is still false

| `procedure LoadURL(const aURL: ustring; const aFrameName: ustring = ''); overload;`
LoadURL will work, even if the browser is still in creation, and Initialized is still false

### Properties

| `property HasBrowser: Boolean read GetHasBrowser;`
This item has no description.

| `property IsClosing : Boolean read GetIsClosing;`
Includes browser in creation

| `property InternalOnBrowserCreated : TNotifyEvent read FInternalOnBrowserCreated write FInternalOnBrowserCreated;`
- Events for use by the Owning component ONLY - Events are called in main thread - OnBrowserCreated: the parent event may be called when procedure Initialized is still false. - OnBrowserCreated: may not be called, if the CloseBrowser has already been called

| `property InternalOnBrowserClosed : TNotifyEvent read FInternalOnBrowserClosed write FInternalOnBrowserClosed;`
This item has no description.

| `property InternalOnGotFocus : TOnGotFocus read FInternalOnGotFocus write FInternalOnGotFocus;`
This item has no description.

Generated by PasDoc 0.16.0-snapshot.